
#include <iostream>
#include <string>
#include <vector>
#include <gtk/gtk.h>
#include "NCCTreeModel.h"

using namespace std;

//--------------------
//delete event
static gboolean gtkDeleteEvent(GtkWidget* widget, GdkEvent *event, gpointer data)
{
		cout<<"quitting.."<<endl;
		gtk_main_quit();
		return FALSE;
}

//--------------------------------
//Cell function
//this function shows the display text from the struct
//**************************
//the problem is somewhere in here!!!
//**************************
void cell_func (GtkTreeViewColumn *col,
                           GtkCellRenderer   *renderer,
                           GtkTreeModel      *model,
                           GtkTreeIter       *iter,
                           gpointer           user_data)
{
	//uncomment this "return" to see the program work
	//this will give us a treeview with no text labels
	//the treeview structure matches the file structure
	//return;
			
	gpointer data = 0;
	gchar* display_text;

	ItemData* p_item = NULL;

	gtk_tree_model_get (model, iter, COL_NUM, &data, -1);
	

	//the pointer value gotten here matches the pointer values from the storage vector entries
	//in nccModelBuilder
	//but the data is corrupted!
	//this crashes sooner or later...mostly sooner
	if (data != NULL)
	{
		p_item = (ItemData*)data;

		display_text = (gchar*)p_item->mDisplayText.c_str();

		g_object_set(renderer, "text", display_text, NULL);
		
		g_free(data);

	}

}

int main(int argc, char* argv[])
{
	GtkWidget* window;
	GtkWidget* treeview;
	GtkWidget* box;
	GtkTreeStore* treestore;
	GtkTreeViewColumn* col;

	//builds the tree model based on an ncc.html file
	NCCTreeModel nccModelBuilder;

	//start GTK
	gtk_init(&argc, &argv);


	//-----------------
	//GUI SETUP

	//make a window
	window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
	g_signal_connect(G_OBJECT(window), "delete_event",
			G_CALLBACK (gtkDeleteEvent), NULL);


	//make a box
	box = gtk_hbox_new(FALSE, 2);
	gtk_container_add (GTK_CONTAINER(window), box);

	//make a tree view
	treeview = gtk_tree_view_new();
	//add the tree view to the box
	gtk_box_pack_start(GTK_BOX(box), treeview, 
				FALSE, FALSE, 0);

	//make a column
	col = gtk_tree_view_column_new();
	gtk_tree_view_append_column(GTK_TREE_VIEW(treeview), col);

	//hide the headers
	gtk_tree_view_set_headers_visible(GTK_TREE_VIEW(treeview), FALSE);

	//----------
	//DATA
	//tree store data collection
	treestore = nccModelBuilder.createModel("c:\\daisy202\\ncc.html");

	//associate the model with the treeview
	gtk_tree_view_set_model (GTK_TREE_VIEW(treeview), GTK_TREE_MODEL(treestore));
	g_object_unref(treestore);

	//------------
	//RENDERING
	//make a renderer
	GtkCellRenderer* renderer;
	renderer = gtk_cell_renderer_text_new();
	gtk_tree_view_column_pack_start(col, renderer, TRUE);

	gtk_tree_view_column_set_cell_data_func(col, renderer, cell_func, NULL, NULL);


	//expand all
	gtk_tree_view_expand_all(GTK_TREE_VIEW(treeview));

	//display stuff
	
	gtk_widget_show(treeview);
	gtk_widget_show(box);
	gtk_widget_show(window);

	gtk_main();

	return 0;
}